#!/usr/bin/perl -w
# v0.1: initial version
# v0.2: write correct size values into header
# v0.3: write 9600Hz file
# v0.4: simplify writing cycle data
use Fcntl qw(:seek);
unless (defined $ARGV[1]) {
  print STDERR "usage: $0 INFILE OUTFILE\n";
  print STDERR "INFILE is Dragon/Tandy CoCo CAS file\n";
  print STDERR "OUTFILE will be 9600Hz WAV\n";
  exit 1;}
die unless open (my $in, "<", $ARGV[0]);
die unless open (my $out, ">", $ARGV[1]);
my $wav_header = "524946460000000057415645666d742010000000010001008025000080250000010008006461746100000000";
print $out pack("H*", $wav_header);
my $count = 0;
my $c;
while (sysread($in, $c, 1) > 0) {
  $c = ord($c);
  for my $i (0..7) {
    if ($c & 0x01) {
      print $out pack("H*", "80ff8001");
      $count += 4;
    } else {
      print $out pack("H*", "80d9ffd980270127");
      $count += 8;}
    $c >>= 1;}}
seek($out, 40, SEEK_SET);
print $out pack("C", $count & 0xff);
print $out pack("C", ($count >> 8) & 0xff);
print $out pack("C", ($count >> 16) & 0xff);
print $out pack("C", ($count >> 24) & 0xff);
$count += 36;
seek($out, 4, SEEK_SET);
print $out pack("C", $count & 0xff);
print $out pack("C", ($count >> 8) & 0xff);
print $out pack("C", ($count >> 16) & 0xff);
print $out pack("C", ($count >> 24) & 0xff);
close $out;
exit 0;
